# opentl::modalities::ColourGMMGPU Class Reference

Inherits opentl::modalities::Modality.

List of all members.

## Public Types
## Public Member Functions
virtual modalities::Modality * | clone () const
| Clone this class and all potential childs RECURSIVELY!! (deep copy).
| ColourGMMGPU (const ColourGMMGPU &c)
| ColourGMMGPU (opentl::modelprojection::Warp *warp, int camIdx, opentl::modelprojection::GLScene *scene, opentl::core::cvdata::ColorGMM *gmm)
virtual void | init ()
| Needed init() method for parameter handling.
virtual int | matchPixLevel (const TargetPtrVector &targets, T_MEAS_PIXPtrVector &outputMeas, std::size_t partitionIdx)
| Match. compare projected features with detected ones use the warped visible features of the hypothesis in order to compute matching residuals meas a pointer to the measurement vector.
virtual int | preProcess (const opentl::core::cvdata::Image &image, const std::vector< std::vector< int > > &preProcessROIs)
| Perform color-space conversion.
void | reinit ()
virtual | ~ColourGMMGPU ()

## Member Enumeration Documentation

enum opentl::modalities::ColourGMMGPU::OfflineParameters

Enumerator:

  useGPU | (bool) use GPU
  OFFLINE_COUNT |

Reimplemented from opentl::modalities::Modality.

enum opentl::modalities::ColourGMMGPU::OnlineParameters

Enumerator:

  matchPXRVariance | (double) match pixel variance
  ONLINE_COUNT |

Reimplemented from opentl::modalities::Modality.

## Constructor & Destructor Documentation

opentl::modalities::ColourGMMGPU::ColourGMMGPU | ( | opentl::modelprojection::Warp * | warp,
|  | int | camIdx,
|  | opentl::modelprojection::GLScene * | scene,
|  | opentl::core::cvdata::ColorGMM * | gmm |
| ) |  |  |

opentl::modalities::ColourGMMGPU::ColourGMMGPU | ( | const ColourGMMGPU & | c | ) |

virtual opentl::modalities::ColourGMMGPU::~ColourGMMGPU | ( |  | ) | `[virtual]`

## Member Function Documentation

virtual modalities::Modality* opentl::modalities::ColourGMMGPU::clone | ( |  | ) | const`[virtual]`

Clone this class and all potential childs RECURSIVELY!! (deep copy).

Implements opentl::modalities::Modality.

virtual void opentl::modalities::ColourGMMGPU::init | ( |  | ) | `[virtual]`

Needed init() method for parameter handling.

Reimplemented from opentl::modalities::Modality.

virtual int opentl::modalities::ColourGMMGPU::matchPixLevel | ( | const TargetPtrVector & | targets,
|  | T_MEAS_PIXPtrVector & | outputMeas,
|  | std::size_t | partitionIdx |
| ) |  |  | `[virtual]`

Match.

- compare projected features with detected ones
- use the warped visible features of the hypothesis in order to compute matching residuals
- meas a pointer to the measurement vector.

Reimplemented from opentl::modalities::Modality.

virtual int opentl::modalities::ColourGMMGPU::preProcess | ( | const opentl::core::cvdata::Image & | image,
|  | const std::vector< std::vector< int > > & | preProcessROIs |
| ) |  |  | `[virtual]`

Perform color-space conversion.

Parameters:

  | image | Input sensor data (e.g. camera image in RGB)
  | preProcessROIs | Regions of interest (x0,y0,width,height), per target

Reimplemented from opentl::modalities::Modality.

void opentl::modalities::ColourGMMGPU::reinit | ( |  | ) |